unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, SHDocVw, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Memo2: TMemo;
    Button12: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    Memo1: TMemo;
    WebBrowser1: TWebBrowser;
    Button1: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    Button3: TButton;
    Button4: TButton;
    Button5: TButton;
    CheckBox1: TCheckBox;
    procedure Button12Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
 Form1: TForm1;
 MDFe_filename: String;
                                                
implementation

{$R *.dfm}

 //Declarao de Funes disponiveis na assinaturaMDFe32dll.dll para assinatura de arquivos XML de MDFe
 //Declao de funes onde o contedo completo do XML a ser assinado  passado como parmtro TStrings
 Function fncAssinarXML(sXml: TStrings): String; SafeCall; external 'assinaturaMDFe32dll.dll';
 Function fncAssinarXMLidx(sXml: TStrings; idx: integer): String; SafeCall; external 'assinaturaMDFe32dll.dll';

 //Declao de funes onde  passado o path do XML a ser assinado e a assinatura  feita diretamente no arquivo
 //Nas funes declaradas (abaixo) a dll utiliza internamente as mesmas funes originais (acima) para fazer a assinatura do arquivo
 Function fncAssinarXMLPath(sXmlPath: Pchar): integer; SafeCall; external 'assinaturaMDFe32dll.dll';
 Function fncAssinarXMLPathidx(sXmlPath: Pchar; idx: integer): integer; SafeCall; external 'assinaturaMDFe32dll.dll';

//--- Remove caracteres invalidos de uma ShortString ---
//Usage: "NotToRemoveStr" is the Char Array NOT to be removed, "FromStr" is the ShortString to be removed from
Function RemoveInvalid(NotToRemoveStr: String; FromStr: String): String;
var
 TempStr: String;
 Res: String;
 x: integer;
begin
 TempStr := UpperCase(FromStr);
 Res := '';
 for x := 1 to Length(TempStr) do
  begin
   if Pos(TempStr[x], NotToRemoveStr) <> 0 then
    Res := Res + FromStr[x];
  end;
 Result := Res;
end;

function RemoveAcento(Str: string): string;
const
 ComAcento = '';
 SemAcento = 'aaeouaoaeioucuAAEOUAOAEIOUCU';
 AlfaArray = 'ABCDEFGHIJKLMNOPQRSTUVWXYZ 0123456789.;,<>?/[]{}*&^%$#@!_+-="`~|\:';
var
   x: Integer;
begin;
 for x := 1 to Length(Str) do
  begin
   if Pos(Str[x],ComAcento) <> 0 then
    Str[x] := SemAcento[Pos(Str[x], ComAcento)];
  end;

 Str := RemoveInvalid(AlfaArray, Str);
 Result := Str;
end;

//Seleo do arquivo de MDFe a ser assinado
procedure TForm1.Button12Click(Sender: TObject);
begin
 //Configura o OpenDialog
 opendialog1.InitialDir := ExtractFileDir(application.ExeName);

 //Solicita que usurio indique o caminho do arquivo
 if OpenDialog1.Execute then
  begin
   MDFe_filename := OpenDialog1.FileName;

   //Abre o arquivo em modo WebBrowsing e em modo texto
   WebBrowser1.Navigate(MDFe_filename);
   memo1.Lines.LoadFromFile(MDFe_filename);

   //Habilitar esta linha para:
   //Garantir que toda acentuao seja removida
   //Caracteres invlidos como quebras de linha indevidas sejam removidos 
   if checkbox1.Checked then
    memo1.lines.Text := RemoveAcento(memo1.lines.Text);
  end;
end;

//Realiza a chamada da assinatura32dll.dll e assina o arquivo de MDFe
procedure TForm1.Button1Click(Sender: TObject);
var
 MDFe_assinada, MDFe_nao_assinada: String;
begin
 try
  //testa se memo1 preenchido
  if memo1.lines.Count > 0 then
   begin
    MDFe_nao_assinada := Memo1.Lines.text;

    //chama a funo de assinatura passando como parmetro o contedo do arquivo selecionado
    //Esta funo NO  compatvel para ser chamada por outras linguagens e plataformas de programao
    //Esta funo NO  compatvel para ser chamada por iMDFeriores ao Delphi6
    MDFe_assinada := fncAssinarXML(Memo1.Lines);
    //MDFe_assinada := fncAssinarXMLidx(Memo1.Lines, 0);    //TODO: Trabalhar com esta chamada alternativa caso deseje passar o ndice do certificado a ser usado na assinatura como um parmetro controlado pela sua aplicao!

    if MDFe_assinada[1] <> '-' then                 //Testa se MDFe asinada corretamente
     begin
      //se nenhum erro ocorreu o retorno  a MDFe assinada
      //Ateno para salvar em formato ANSI remover caracteres iniciais do resultado assinado
      memo2.Lines.Text := copy(MDFe_assinada, 4, length(MDFe_assinada));

      memo1.Lines.Text := MDFe_nao_assinada;

      showmessage('MDFe assinada com sucesso');
     end
    else
     memo2.Lines.Text := MDFe_assinada;            //Apresenta erro/advertncia ao usurio retornado pela dll
   end
  else
   showmessage('Contedo invlido. Selecione o arquivo XML da MDFe')
 except
  showmessage('Erro durante o processo de assinatura. Verifique!');
 end;


end;

function Tamanho_Arquivo(Path_Arquivo: String): Double;
var
 Arquivo: File of Byte;
begin
 Result := 0;

 if FileExists(Path_Arquivo) then
  begin
   AssignFile(Arquivo, Path_Arquivo);     //Transforma o arquivo em bytes independente de sua extenso
   Reset(Arquivo);
   Result := (FileSize(Arquivo) / 1024);  //Retorna o tamanho do arquivo em Kbytes
   CloseFile(Arquivo);
  end;
end;

//Salva o arquivo de MDFe devidamente assinado
procedure TForm1.Button2Click(Sender: TObject);
var
 UTF8_Str: String;
begin
 try
  //configura o SaveDialog
  savedialog1.InitialDir := ExtractFileDir(application.ExeName);
  SaveDialog1.FileName := ExtractFileName(MDFe_filename);

  //Realiza o salvamento do arquivo conforme path escolhido pelo usurio
  if savedialog1.Execute then
   begin
    //Alteraes para realizar salvamento em formato UTF-8
    //UTF8_Str := Memo2.Lines.Text;
    //UTF8_Str := UTF8Encode(UTF8_Str);
    //UTF8_Str := char($EF) + char($BB) + char($BF) + UTF8_Str;   //adding BOM
    //Memo2.Lines.Text := UTF8_Str;

    //Salvando o arquivo
    memo2.Lines.SaveToFile(savedialog1.filename);

    //Testa tamanho do arquivo final
    //Conforme Manual de Integrao da SEFAZ o tamanho mximo dos arquivos para transmisso  de 500Kb!
    if Tamanho_Arquivo(savedialog1.filename) > 500 then
     showmessage('ATENO: Tamanho mximo de 500KB por arquivo excedido. Este arquivo no poder ser trasmitido');
   end;
 except
  showmessage('Erro durante o salvamento do arquivo de MDFe assinado');
  exit;
 end;

 showmessage('Arquivo de MDFe salvo com sucesso.' + #13#10 +
             'Ateno: Para transmitir arquivos de MDFe  preciso antes gerar um arquivo de Lote contendo uma ou mais MDFe assinadas' + #13#10 +
             'Consulte o demo localizado na pasta Geracao_XML\enviMDFe para informaes sobre gerao de lotes de MDFe')

end;

//Sistema volta a solicitar que o usurio selecione o certificado desejado para a assinatura
//Esta funcionalidade pode ser implementada em seu aplicativo final para desfazer a opo implementada na tela da dll
procedure TForm1.Button3Click(Sender: TObject);
var
 myfilename: String;
begin
 try
  //Configura o diretrio onde se encontra o arquivo que armazena o ndice
  //Da forma que est implementada aqui s funciona se a dll estiver localizada no mesmo diretrio do .exe
  myfilename := ExtractFilePath(application.ExeName) + '\DefCertificado.res';

  //testa se arquivo existe
  if fileexists(myfilename) then
   begin
    //exclue o arquivo q armazena o indice
    //Usurio logado no windows deve ter permisses sobre o diretrio e o arquivo em questo
    DeleteFile(myfilename);

    showmessage('Arquivo' + myfilename + 'excludo. O sistema voltar a solicitar que o usurio selecione o certificado desejado para a assinatura');
   end;
 except
  showmessage('Erro durante excluso do arquivo ' + myfilename)
 end;

end;

procedure TForm1.Button4Click(Sender: TObject);
var
 MDFe_assinada: integer;
begin
 try
  //testa se memo1 preenchido
  if memo1.lines.Count > 0 then
   begin
    //chama a funo de assinatura passando como parmetro o path do arquivo selecionado
    //Funo principal da dll que executa a assinatura dos arquivos
    //Esta funo assina e altera diretamente o contedo do arquivo indicado que no deve estar em uso por nenhuma outra aplicao
    //Esta funo  compatvel cpara ser chamada por outras linguagens e plataformas de programao
    MDFe_assinada := fncAssinarXMLPath(PChar(MDFe_filename));
    //MDFe_assinada := fncAssinarXMLPathidx(PChar(MDFe_filename), 0);    //TODO: Trabalhar com esta chamada alternativa caso deseje passar o ndice do certificado a ser usado na assinatura como um parmetro controlado pela sua aplicao!


    if MDFe_assinada = 1 then
     begin
      memo2.Lines.LoadFromFile(MDFe_filename);

      memo2.Lines.Text := copy(memo2.Lines.Text, 4, length(memo2.Lines.Text));
     end
    else
     begin
      showmessage('Erro durante o processo de assinatura. Verifique!');
      exit;
     end;
   end
  else
   begin
    showmessage('Contedo invlido. Selecione o arquivo XML da MDFe');
    exit;
   end;
 except
  showmessage('Erro durante o processo de assinatura. Verifique!');
  exit;
 end;

 showmessage('MDFe assinada com sucesso');

end;

procedure TForm1.Button5Click(Sender: TObject);
begin
 memo1.Lines.Clear;
 memo2.Lines.clear;
end;

end.

